// dll.cpp - written and placed in the public domain by Wei Dai

#if defined( __GNUC__ ) && __GNUC__ > 3
#	undef CRYPTOPP_MANUALLY_INSTANTIATE_TEMPLATES
#else
#	define CRYPTOPP_MANUALLY_INSTANTIATE_TEMPLATES
#endif
#define CRYPTOPP_DEFAULT_NO_DLL

#include "dll.h"
#ifdef _MSC_VER
#pragma warning(default: 4660)
#endif

#ifdef CRYPTOPP_WIN32_AVAILABLE
#include <windows.h>
#endif

#include "iterhash.cpp"
#include "strciphr.cpp"
#include "algebra.cpp"
#include "eprecomp.cpp"
#include "eccrypto.cpp"

#ifndef CRYPTOPP_IMPORTS

NAMESPACE_BEGIN(CryptoPP)

#ifdef __MWERKS__
// CodeWarrior 8 workaround: explicit instantiations have to appear after member function definitions
CRYPTOPP_DLL_TEMPLATE_CLASS DL_GroupParameters_EC<ECP>;
CRYPTOPP_DLL_TEMPLATE_CLASS DL_GroupParameters_EC<EC2N>;
CRYPTOPP_DLL_TEMPLATE_CLASS DL_FixedBasePrecomputationImpl<Integer>;
CRYPTOPP_STATIC_TEMPLATE_CLASS IteratedHashBase<word64, HashTransformation>;
CRYPTOPP_DLL_TEMPLATE_CLASS IteratedHashBase<word32, HashTransformation>;
CRYPTOPP_STATIC_TEMPLATE_CLASS IteratedHashBase<word32, MessageAuthenticationCode>;
CRYPTOPP_DLL_TEMPLATE_CLASS CFB_CipherTemplate<AbstractPolicyHolder<CFB_CipherAbstractPolicy, CFB_ModePolicy> >;
CRYPTOPP_DLL_TEMPLATE_CLASS CFB_EncryptionTemplate<AbstractPolicyHolder<CFB_CipherAbstractPolicy, CFB_ModePolicy> >;
CRYPTOPP_DLL_TEMPLATE_CLASS CFB_DecryptionTemplate<AbstractPolicyHolder<CFB_CipherAbstractPolicy, CFB_ModePolicy> >;
CRYPTOPP_DLL_TEMPLATE_CLASS AdditiveCipherTemplate<>;
CRYPTOPP_DLL_TEMPLATE_CLASS AdditiveCipherTemplate<AbstractPolicyHolder<AdditiveCipherAbstractPolicy, OFB_ModePolicy> >;
CRYPTOPP_DLL_TEMPLATE_CLASS AdditiveCipherTemplate<AbstractPolicyHolder<AdditiveCipherAbstractPolicy, CTR_ModePolicy> >;
CRYPTOPP_DLL_TEMPLATE_CLASS AbstractEuclideanDomain<Integer>;
#endif

#if defined(__GNUC__) && __GNUC__ > 3
template class CRYPTOPP_DLL AbstractEuclideanDomain<Integer>;
template class CRYPTOPP_DLL AbstractEuclideanDomain<PolynomialMod2>;
template class CRYPTOPP_DLL AbstractGroup<Integer>;
template class CRYPTOPP_DLL AbstractGroup<EC2NPoint>;
template class CRYPTOPP_DLL AbstractGroup<ECPPoint>;
template class CRYPTOPP_DLL AbstractGroup<PolynomialMod2>;
template class CRYPTOPP_DLL AbstractPolicyHolder<AdditiveCipherAbstractPolicy, TwoBases<SimpleKeyedTransformation<StreamTransformation>, RandomNumberGenerator> >;
template class CRYPTOPP_DLL AbstractRing<Integer>;
template class CRYPTOPP_DLL AbstractRing<PolynomialMod2>;
template class CRYPTOPP_DLL AdditiveCipherTemplate<>;
template class CRYPTOPP_DLL AdditiveCipherTemplate<AbstractPolicyHolder<AdditiveCipherAbstractPolicy, CTR_ModePolicy> >;
template class CRYPTOPP_DLL AdditiveCipherTemplate<AbstractPolicyHolder<AdditiveCipherAbstractPolicy, OFB_ModePolicy> >;
template class CRYPTOPP_DLL AllocatorWithCleanup<byte>;
template class CRYPTOPP_DLL AllocatorWithCleanup<word16>;
template class CRYPTOPP_DLL AllocatorWithCleanup<word32>;
template class CRYPTOPP_DLL AutoSeededX917RNG<DES_EDE3>;
template class CRYPTOPP_DLL CFB_CipherTemplate<AbstractPolicyHolder<CFB_CipherAbstractPolicy, CFB_ModePolicy> >;
template class CRYPTOPP_DLL CFB_CipherTemplate<AbstractPolicyHolder<CFB_CipherAbstractPolicy, SymmetricCipher> >;
template class CRYPTOPP_DLL CFB_DecryptionTemplate<>;
template class CRYPTOPP_DLL CFB_DecryptionTemplate<AbstractPolicyHolder<CFB_CipherAbstractPolicy, CFB_ModePolicy> >;
template class CRYPTOPP_DLL CFB_EncryptionTemplate<>;
template class CRYPTOPP_DLL CFB_EncryptionTemplate<AbstractPolicyHolder<CFB_CipherAbstractPolicy, CFB_ModePolicy> >;
template class CRYPTOPP_DLL CipherModeFinalTemplate_ExternalCipher<CBC_CTS_Decryption>;
template class CRYPTOPP_DLL CipherModeFinalTemplate_ExternalCipher<CBC_CTS_Encryption>;
template class CRYPTOPP_DLL CipherModeFinalTemplate_ExternalCipher<CBC_Decryption>;
template class CRYPTOPP_DLL CipherModeFinalTemplate_ExternalCipher<CBC_Encryption>;
template class CRYPTOPP_DLL CipherModeFinalTemplate_ExternalCipher<ECB_OneWay>;
template class CRYPTOPP_DLL DH_Domain<DL_GroupParameters_GFP_DefaultSafePrime>;
template class CRYPTOPP_DLL DL_Algorithm_GDSA<EC2N::Point>;
template class CRYPTOPP_DLL DL_Algorithm_GDSA<ECP::Point>;
template class CRYPTOPP_DLL DL_Algorithm_GDSA<Integer>;
template class CRYPTOPP_DLL DL_FixedBasePrecomputationImpl<EC2N::Point>;
template class CRYPTOPP_DLL DL_FixedBasePrecomputationImpl<ECPPoint>;
template class CRYPTOPP_DLL DL_FixedBasePrecomputationImpl<Integer>;
template class CRYPTOPP_DLL DL_GroupParameters<Integer>;
template class CRYPTOPP_DLL DL_GroupParameters_EC<EC2N>;
template class CRYPTOPP_DLL DL_GroupParameters_EC<ECP>;
template class CRYPTOPP_DLL DL_GroupParameters_IntegerBasedImpl<ModExpPrecomputation>;
template class CRYPTOPP_DLL DL_GroupPrecomputation<EC2N::Point>;
template class CRYPTOPP_DLL DL_GroupPrecomputation<ECPPoint>;
template class CRYPTOPP_DLL DL_PrivateKeyImpl<DL_GroupParameters_EC<EC2N> >;
template class CRYPTOPP_DLL DL_PrivateKeyImpl<DL_GroupParameters_EC<ECP> >;
template class CRYPTOPP_DLL DL_PrivateKey_EC<EC2N>;
template class CRYPTOPP_DLL DL_PrivateKey_EC<ECP>;
template class CRYPTOPP_DLL DL_PrivateKey_GFP<DL_GroupParameters_DSA>;
template class CRYPTOPP_DLL DL_PrivateKey_WithSignaturePairwiseConsistencyTest<DL_PrivateKey_EC<EC2N>, ECDSA<EC2N> >;
template class CRYPTOPP_DLL DL_PrivateKey_WithSignaturePairwiseConsistencyTest<DL_PrivateKey_EC<ECP>, ECDSA<ECP> >;
template class CRYPTOPP_DLL DL_PrivateKey_WithSignaturePairwiseConsistencyTest<DL_PrivateKey_GFP<DL_GroupParameters_DSA>, DSA>;
template class CRYPTOPP_DLL DL_PublicKeyImpl<DL_GroupParameters_EC<EC2N> >;
template class CRYPTOPP_DLL DL_PublicKeyImpl<DL_GroupParameters_EC<ECP> >;
template class CRYPTOPP_DLL DL_PublicKey_EC<EC2N>;
template class CRYPTOPP_DLL DL_PublicKey_EC<ECP>;
template class CRYPTOPP_DLL DL_PublicKey_GFP<DL_GroupParameters_DSA>;
template class CRYPTOPP_DLL EuclideanDomainOf<PolynomialMod2>;
template class CRYPTOPP_DLL IteratedHashBase<word32, HashTransformation>;
template class CRYPTOPP_DLL IteratedHashBase<word32, MessageAuthenticationCode>;
#ifdef WORD64_AVAILABLE
template class CRYPTOPP_DLL IteratedHashBase<word64, HashTransformation>;
template class CRYPTOPP_DLL IteratedHashBase<word64, MessageAuthenticationCode>;
#endif
template class CRYPTOPP_DLL OAEP<SHA>;
#ifdef CRYPTOPP_IS_DLL
template class CRYPTOPP_DLL PKCS_DigestDecoration<SHA>;
#endif
template class CRYPTOPP_DLL QuotientRing<EuclideanDomainOf<PolynomialMod2> >;
template class CRYPTOPP_DLL SimpleKeyedTransformation<BlockTransformation>;
template class CRYPTOPP_DLL SimpleKeyedTransformation<HashTransformation>;
template class CRYPTOPP_DLL SimpleKeyedTransformation<StreamTransformation>;
template class CRYPTOPP_DLL StringSinkTemplate<std::string>;
template class CRYPTOPP_DLL TwoBases<SymmetricCipher, RandomNumberGenerator>;
#endif // __GNUC__ > 3

template<> const byte PKCS_DigestDecoration<SHA>::decoration[] = {0x30,0x21,0x30,0x09,0x06,0x05,0x2B,0x0E,0x03,0x02,0x1A,0x05,0x00,0x04,0x14};
template<> const unsigned int PKCS_DigestDecoration<SHA>::length = sizeof(PKCS_DigestDecoration<SHA>::decoration);

NAMESPACE_END

#endif

#ifdef CRYPTOPP_EXPORTS

USING_NAMESPACE(CryptoPP)

#if !(defined(_MSC_VER) && (_MSC_VER < 1300))
using std::set_new_handler;
#endif

static PNew s_pNew = NULL;
static PDelete s_pDelete = NULL;

static void * CRYPTOPP_CDECL New (size_t size)
{
	void *p;
	while (!(p = malloc(size)))
		CallNewHandler();

	return p;
}

static void SetNewAndDeleteFunctionPointers()
{
	void *p = NULL;
	HMODULE hModule = NULL;
	MEMORY_BASIC_INFORMATION mbi;

	while (true)
	{
		VirtualQuery(p, &mbi, sizeof(mbi));

		if (p >= (char *)mbi.BaseAddress + mbi.RegionSize)
			break;

		p = (char *)mbi.BaseAddress + mbi.RegionSize;

		if (!mbi.AllocationBase || mbi.AllocationBase == hModule)
			continue;

		hModule = HMODULE(mbi.AllocationBase);

		PGetNewAndDelete pGetNewAndDelete = (PGetNewAndDelete)GetProcAddress(hModule, "GetNewAndDeleteForCryptoPP");
		if (pGetNewAndDelete)
		{
			pGetNewAndDelete(s_pNew, s_pDelete);
			return;
		}

		PSetNewAndDelete pSetNewAndDelete = (PSetNewAndDelete)GetProcAddress(hModule, "SetNewAndDeleteFromCryptoPP");
		if (pSetNewAndDelete)
		{
			s_pNew = &New;
			s_pDelete = &free;
			pSetNewAndDelete(s_pNew, s_pDelete, &set_new_handler);
			return;
		}
	}

	hModule = GetModuleHandle("msvcrtd");
	if (!hModule)
		hModule = GetModuleHandle("msvcrt");
	if (hModule)
	{
		s_pNew = (PNew)GetProcAddress(hModule, "??2@YAPAXI@Z");		// operator new
		s_pDelete = (PDelete)GetProcAddress(hModule, "??3@YAXPAX@Z");	// operator delete
		return;
	}

	OutputDebugString("Crypto++ was not able to obtain new and delete function pointers.\n");
	throw 0;
}

void * CRYPTOPP_CDECL operator new (size_t size)
{
	if (!s_pNew)
		SetNewAndDeleteFunctionPointers();

	return s_pNew(size);
}

void CRYPTOPP_CDECL operator delete (void * p)
{
	s_pDelete(p);
}

void * CRYPTOPP_CDECL operator new [] (size_t size)
{
	return operator new (size);
}

void CRYPTOPP_CDECL operator delete [] (void * p)
{
	operator delete (p);
}

#endif	// #ifdef CRYPTOPP_EXPORTS
